EDIT - bug #10214

Cache configuration for term cache not correctly initialized in taxeditor
12/21/2022 01:13 PM - Andreas Muller
Target version: Release 5.35

Severity: normal Found in Version:

Description

This results in short time-to-live and time-to-idle values (and maybe others) as values are taken from default ehCache configuration
instead of cdm EhCacheConfiguration and has 2 min instead of 2 h.

The reason is that currently the class EhCacheConfiguration in method cacheManager() calls CacheManager.create(config).
However, if the CacheManager singleton has already been created previously the passed configuration parameter has no effect.

If CacheManager.create() is called a singleton with a default cache configuration is created. This configuration can not be exchanged
anymore later.

In TaxEditor the CacheManager singleton is already created when CdmRemoteCacheManager is initialized (contructor line 65) which
is prior to calling CdmCacherBase.getDefaultCacheConfiguration().

CdmTransientEntityCache: the transient entity cache works already correctly as it creates a cache with a given configuration in its
constructor

Solutions:

e do not use the CacheManager singleton (but be careful to be thread safe) => no real reason for doing so
¢ use a specific cache configuration when the cdmDefaultCache is created (this seems to happen in
CdmCacherBase.getDefaultCache()) => chosen solution, similar to transient entity cache

NOTE: do also adapt path to taxeditor ehcache in DiskStoreConfiguration of setUpCacheManager() configuration after the above is
fixed => moved to #10218

Related issues:

Related to EDIT - bug #10186: Problems with session handling in taxeditor Closed
Related to EDIT - task #10077: upgrade ehcache to 3.x New
Related to EDIT - task #10218: Unify cache handling in CDM platform New

Associated revisions

Revision 61cf7e7a - 01/04/2023 11:32 PM - Andreas Miiller

fix #10214 fix term (default) cache configuration handling

Revision ¢19e393b - 01/05/2023 12:48 AM - Andreas Miiller

ref #10214 adapt vaadin to new CdmPermanentCacheBase name

Revision 23732475 - 01/05/2023 01:05 AM - Andreas Miiller

ref #10214 rename CdmCacheBase to CdmPermanentCacheBase

Revision 87734bf5 - 01/05/2023 01:13 AM - Andreas Miiller

ref #10214 rename CdmCacheBase to CdmPermanentCacheBase in TaxEditor

Revision 28a2e0b5 - 01/05/2023 01:34 AM - Andreas Miiller

ref #10214 rename CdmCacheBase to CdmPermanentCacheBase in TaxEditor (cont.)

Revision af15e2e3 - 01/05/2023 01:51 PM - Andreas Miiller
fix #10214 fix overriden cache configuration creation, replace eternal by 1h / 20min

History

#1 - 12/21/2022 01:13 PM - Andreas Miiller
- Related to bug #10186: Problems with session handling in taxeditor added

#2 - 12/21/2022 01:19 PM - Andreas Miiller

Also it is unclear why single instances of CdmServiceCachingProxy to all use the static DEFAULT_CACHE_NAME from the base class. There might
be only 1 such cache but still this is very dirty.

#3 - 12/21/2022 01:21 PM - Andreas Miiller

- Description updated

#4 - 12/26/2022 01:01 PM - Andreas Miiller
- Related to task #10077: upgrade ehcache to 3.x added

#5 - 01/03/2023 05:50 PM - Andreas Miiller
- Status changed from New to In Progress

- % Done changed from 0 to 10

#6 - 01/04/2023 12:24 AM - Andreas Miiller

- Status changed from In Progress to Feedback

This should still be handled in current target version.

#7 - 01/04/2023 10:10 PM - Andreas Miiller
- Related to task #10218: Unify cache handling in CDM platform added

#8 - 01/04/2023 11:30 PM - Andreas Miiller

- Subject changed from Cache configuration not handled correctly in taxeditor to Cache configuration for term cache not correctly in taxeditor

#9 - 01/04/2023 11:40 PM - Andreas Miiller
- Status changed from Feedback to Resolved

- % Done changed from 10 to 70

Applied in changeset cdmlib|61cf7e7af3a0e164f63cb40ec9d897783e376dca.

#10 - 01/04/2023 11:53 PM - Andreas Miiller

- Description updated

- Assignee changed from Andreas Muiller to Katja Luther
- Priority changed from New to Highest

This should be fixed. Please review.

The most important result should be, that terms are not loaded anymore when changing focus e.g. in Taxon Editor. Only after 2h they should be
reloaded. However, we should check that there are no side effects introduced by the change.

#11 - 01/05/2023 12:00 AM - Andreas Miiller
- Description updated

#12 - 01/05/2023 12:00 AM - Andreas Miiller
- Description updated

#13 - 01/05/2023 09:50 AM - Katja Luther

Andreas Muller wrote in #note-10:

This should be fixed. Please review.
The most important result should be, that terms are not loaded anymore when changing focus e.g. in Taxon Editor. Only after 2h they should be
reloaded. However, we should check that there are no side effects introduced by the change.

This works fine, actually could not test yet, what happens after two hours.
#14 - 01/05/2023 12:44 PM - Andreas Miiller
Katja Luther wrote in #note-13:
Andreas Miiller wrote in #note-10:
This should be fixed. Please review.
The most important result should be, that terms are not loaded anymore when changing focus e.g. in Taxon Editor. Only after 2h they
should be reloaded. However, we should check that there are no side effects introduced by the change.

This works fine, actually could not test yet, what happens after two hours.

| checke with an open-over-night instance and for some reason it did not reload. | check now with an adapted time (15s) in
CdmPermanentCacheBase.getPermanentCacheConfiguration()

#15 - 01/05/2023 12:44 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Katja Luther to Andreas Mdiller

Ahh, the reason is that CdmServiceCachingProxy overrides the CdmPermanentCache configuration

#16 - 01/05/2023 01:52 PM - Andreas Miiller

- Status changed from Feedback to Resolved

Applied in changeset taxeditor|af15e2e37989{818b9098b604242a02adf295818.

#17 - 01/05/2023 03:19 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther

Now it should reload after 20min (if idle) or 1h (if not idle). Maybe you can test a last time. But it should work as expected.

#18 - 01/05/2023 03:33 PM - Andreas Miiller

- Subject changed from Cache configuration for term cache not correctly in taxeditor to Cache configuration for term cache not correctly initialized in

taxeditor

#19 - 09/26/2023 01:00 PM - Katja Luther
- Status changed from Resolved to Closed

- Assignee changed from Katja Luther to Andreas Mdiller

| tested it with an idle editor and after this time terms will be reloaded, terms already reloaded are not loaded again, so | think it works as expected.
